#include "Eigen/Dense"
#include <iostream>
#include <cassert>

template<typename T, int M>
Eigen::Matrix<T,M,1> g(const Eigen::Matrix<T,M,1> &x) { return x; }

template<typename T, int M>
T Householder(Eigen::Matrix<T,M,1> x, Eigen::Matrix<T,M,1> y) {
  using VT=Eigen::Matrix<T,M,1>; using MT=Eigen::Matrix<T,M,M>;
  auto m=x.size();
  VT v=x+x(0)/fabs(x(0))*x.norm()*VT::Unit(m,0);
  std::cout << "v^T=" << v.transpose() << std::endl;
  MT H=MT::Identity(m,m)-2*v*v.transpose()/v.dot(v);
  std::cout << "H=" << std::endl << H << std::endl;
  x=H*x; y=H*y;
  std::cout << "x^T=(Gx)^T=" << x.transpose() << std::endl
            << "y^T=(Gy)^T=" << y.transpose() << std::endl;
  return y(0)/x(0);
}

int main(int argc, char* argv[]) {
  assert(argc==2); auto M=std::stoi(argv[1]);
  using T=float; 
  using VT=Eigen::Matrix<T,Eigen::Dynamic,1>;
  VT x=VT::Random(M), y=VT::Random(M); 
  x=x.cwiseProduct(x);
  std::cout << "x^T=" << x.transpose() << std::endl
            << "y^T=" << y.transpose() << std::endl;
  T p=Householder(g(x),y);
  std::cout << "p=" << p << std::endl;
  return 0;
}
