#include "Eigen/Dense"
#include <iostream>
#include <cassert>

template<typename T, int M>
Eigen::Matrix<T,M,1> g(const Eigen::Matrix<T,M,1> &x) { return x; }

template<typename T, int M>
T NormalEquation(const Eigen::Matrix<T,M,1> &x, Eigen::Matrix<T,M,1> &y) {
  return y.dot(x)/x.dot(x);
}

int main(int argc, char* argv[]) {
  assert(argc==2); auto M=std::stoi(argv[1]);
  using T=float; 
  using VT=Eigen::Matrix<T,Eigen::Dynamic,1>;
  VT x=VT::Random(M), y=VT::Random(M); 
  x=x.cwiseProduct(x);
  std::cout << "x^T=" << x.transpose() << std::endl
            << "y^T=" << y.transpose() << std::endl;
  T p=NormalEquation(g(x),y);
  std::cout << "p=" << p << std::endl;
  return 0;
}
